function dashboard_widget (instance, widget) {
    "use strict";

    var widgets = widget;

    widget.DashboardWidget = instance.Widget.extend({
        template: 'DashboardTmpl',
        widgets: [
            {
                title: 'Clientes',
                name: 'CustomerCounterWidget'
            }
        ],
        grid: {},
        start: function () {
            this.$el.find('.grid-stack.dashboard').gridstack({
                animate: true,
            });
            this.grid = this.$el.find('.grid-stack.dashboard').data('gridstack');
            this.renderWidgets();
        },
        renderWidgets: function () {
            // Cliente con Saldo Vencido
            var wExpiredAccount = new widgets.ExpiredAccountCountersWidget(this);
            wExpiredAccount.renderElement();
            wExpiredAccount.start();
            this.grid.addWidget(wExpiredAccount.$el, 0, 0, wExpiredAccount.size.width,  wExpiredAccount.size.height, true);
            // Cliente a Cobrar oi
            var wExpiredAccountNow = new widgets.ExpiredAccountCountersNowWidget(this);
            wExpiredAccountNow.renderElement();
            wExpiredAccountNow.start();
            this.grid.addWidget(wExpiredAccountNow.$el, 0, 0, wExpiredAccountNow.size.width,  wExpiredAccountNow.size.height, true);
            // Pagados oi
            var wVocuherToday = new widgets.VoucherTodayCountersWidget(this);
            wVocuherToday.renderElement();
            wVocuherToday.start();
            this.grid.addWidget(wVocuherToday.$el, 0, 0, wVocuherToday.size.width,  wVocuherToday.size.height, true);

            var wInvoiceToday = new widgets.InvoiceTodayCountersWidget(this);
            wInvoiceToday.renderElement();
            wInvoiceToday.start();
            this.grid.addWidget(wInvoiceToday.$el, 0, 0, wInvoiceToday.size.width,  wInvoiceToday.size.height, true);
            //Ranking de Ventas de Producto por Mes
            var wRankingProduct = new widgets.RankingSalesProductWidget(this);
            wRankingProduct.renderElement();
            wRankingProduct.start();
            this.grid.addWidget(wRankingProduct.$el, 0, 0, wRankingProduct.size.width,  wRankingProduct.size.height, true);
            // for (var i = 1; i <= 4; i++) {
            //     var widget = new widgets.CustomerCounterWidget(this);
            //     widget.renderElement();
            //     // widget.start();
            //
            //     this.grid.addWidget(widget.$el, 0, 0, widget.getWidth(),  widget.getHeight(), true);
            // }
            //
            // var w = new widgets.SalesInTheWeekWidget(this);
            // w.renderElement();
            // w.start();
            //
            // this.grid.addWidget(w.$el, 0, 0, w.size.width,  w.size.height, true);
            //
            // var w2 = new widgets.TopSalesProductWidget(this);
            // w2.renderElement();
            // w2.start();
            //
            // this.grid.addWidget(w2.$el, 0, 0, w2.size.width,  w2.size.height, true);
            //
            // var w3 = new widgets.SalesInWarehouseByBrandWidget(this);
            // w3.renderElement();
            // w3.start();
            //
            // this.grid.addWidget(w3.$el, 0, 0, w3.size.width,  w3.size.height, true);
        }
    });
}
